; 

      .686                      ; create 32 bit code
      .MMX
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      include \masm32\include\dialogs.inc

      DlgProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD
      hex2bin  PROTO :DWORD,:DWORD

    .data?
      hWnd      dd ?
      hInstance dd ?
      tc1       dd ?
      tc2       dd ?

    .data
      align 16
      multitable \
        db 0,0,0,0,0,0,0,0,0,0,2,0,0,2,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0
        db 1,1,1,1,1,1,1,1,1,1,0,3,0,0,0,0
        db 0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

      ; 0 = unacceptable character
      ; 1 = acceptable characters   (0 to 9, A to F, a to f)
      ; 2 = ignored characters      (space, minus and CRLF)
      ; 3 = comment character       ( ; )

      ; 1st offset table
        db 00h,10h,20h,30h,40h,50h,60h,70h,80h,90h,0,0,0,0,0,0      ; 63
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h,0,0,0,0,0,0,0,0,0      ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h

      ; 2nd offset table
        db 00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0,0,0,0,0,0      ; 63
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh,0,0,0,0,0,0,0,0,0            ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh

      ; add 256 for allowable character table
      ; sub 48 from 1st offset table
      ; add 7 for the second BYTE

      allfiles db "All Files",0,"*.*",0,0

    .code

; 

start:
  
      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    Dialog "HEX to Binary", \               ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            3, \                            ; number of controls
            50,50,155,100, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Select",WS_TABSTOP,106,5,40,13,IDOK
    DlgButton "Cancel",WS_TABSTOP,106,20,40,13,IDCANCEL
    DlgStatic "Select HEX file >>>",SS_LEFT,35,7,60,9,100

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL wlen  :DWORD
    LOCAL fname :DWORD
    LOCAL flen  :DWORD
    LOCAL pMem  :DWORD
    LOCAL hMem  :DWORD
    LOCAL fntst :DWORD
    LOCAL buffer[128]:BYTE

    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case IDOK

            mov fname, OpenFileDlg(hWnd,hInstance,"Open file ...",ADDR allfiles)
            cmp BYTE PTR [eax], 0
            jne @F
            return 0
          @@:

            mov pMem, InputFile(fname)
            mov flen, ecx

            mov edx, pMem
            add edx, flen
            mov BYTE PTR [edx], 0

            shr ecx, 1
            mov hMem, alloc(ecx)        ; allocate half buffer size for output.

            invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

          ; **************************************************************************

            invoke GetTickCount
            mov tc1, eax

            invoke hex2bin,pMem,hMem
            mov wlen, eax
            mov fntst, ecx

            invoke GetTickCount
            sub eax, tc1
            invoke SetWindowText,hWnd,str$(eax)

          ; **************************************************************************

            invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

            free pMem

            Switch fntst
              Case 0
                fn MessageBox,hWnd,"Conversion was successful",str$(wlen),MB_OK
              Case 1
                fn MessageBox,hWnd,"Invalid character",str$(wlen),MB_OK
              Case 2
                fn MessageBox,hWnd,"Hex must be in '00 FF 5D DF' character paired format",str$(wlen),MB_OK
            EndSw

            mov fname, SaveFileDlg(hWin,hInstance,"Save Converted File As ...",ADDR allfiles)
            cmp BYTE PTR [eax], 0
            jne @F
            free hMem
            return 0
          @@:

            cmp OutputFile(fname,hMem,wlen), 0
            jne @F
            fn MessageBox,hWnd,"Something went wrong","hmmmmm,",MB_OK
          @@:

            free hMem

          Case IDCANCEL
            jmp quit_dialog
        EndSw
      Case WM_CLOSE
        quit_dialog:
         invoke EndDialog,hWin,0
    EndSw

    return 0

DlgProc endp

; 

align 4

hex2bin proc src:DWORD,dst:DWORD

comment * --------------------------------------------------
        In the proc, EAX and EBX are unused in the loop code
        -------------------------------------------------- *

    push ebx
    push esi
    push edi
    push ebp

    mov esi, src
    mov edi, dst

    xor ebp, ebp

    jmp h2b                             ; mispredicted only once

  align 4
  stripcomment:
    add esi, 1
    cmp BYTE PTR [esi], 10
    jb zerofound                        ; < 10 = 0
    jne stripcomment                    ; loop if not 10
  align 4
  pre:
    add esi, 1
  align 4
  h2b:
    movzx ebp, BYTE PTR [esi]           ; zero extend 1st byte into EBP
    cmp BYTE PTR [ebp+multitable], 2    ; 1st compare short circuit on ignored characters
    je pre                              ; predicted backwards
    movzx edx, BYTE PTR [esi+1]         ; zero extend 2nd BYTE into EDX
    ja stripcomment                     ; predicted backwards

    mov cl, [ebp+multitable+208]        ; load 1st character into CL from 2nd table
    add cl, [edx+multitable+263]        ; add value of second character from 3rd table
    cmp BYTE PTR [ebp+multitable], 0    ; exit on error or ZERO
    je error1                           ; mispredicted only once

    mov [edi], cl                       ; write BYTE to output buffer
    add esi, 2
    add edi, 1
    cmp BYTE PTR [edx+multitable], 1    ; test if second byte is allowable character
    je h2b                              ; predicted backwards

  error2:
    mov ecx, 2                          ; error 2
    jmp exitproc
  error1:
    test ebp, ebp                       ; test if byte is terminator
    jz zerofound
    mov ecx, 1                          ; error 1
    jmp exitproc
  zerofound:
    xor ecx, ecx                        ; no error 0

  exitproc:

    pop ebp                             ; restore EBP before using stack parameter
    sub edi, dst
    mov eax, edi

    pop edi
    pop esi
    pop ebx

    ret

hex2bin endp

; 

end start
